// CallLogEntry.cpp: CCallLogEntry NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CallLogEntry.h"

static
LPTSTR
DupString(
	LPTSTR pStr
)
{
	LPTSTR	pRet = NULL;

	if (pStr != NULL) {
		DWORD	dwLen = _tcslen(pStr);

		try {
			pRet = new TCHAR[(dwLen + 1) * sizeof(TCHAR)];
			if (pRet != NULL) {
				_tcscpy(pRet, pStr);
			}
		}
		catch(...) {
			;
		}
	}

	return pRet;
}

static
LPTSTR
DupStringLocalAlloc(
	LPTSTR pStr
)
{
	LPTSTR	pRet = NULL;

	if (pStr != NULL) {
		DWORD	dwLen = _tcslen(pStr);

		pRet = (LPTSTR)LocalAlloc(LPTR, (dwLen + 1) * sizeof(TCHAR));
		if (pRet != NULL) {
			_tcscpy(pRet, pStr);
		}
	}

	return pRet;
}


CCallLogEntry::CCallLogEntry()
{
	m_Type = CALLLOGENTRY_TYPE_CALLING;
	m_pszNumber = NULL;
	m_pszName = NULL;
	m_dwFlag = 0;
}

CCallLogEntry::CCallLogEntry(
	CALLLOGENTRY_TYPE	type,
	LPTSTR				pNumber,
	LPTSTR				pName,
	FILETIME*			pftCallTime,
	DWORD				dwFlag
)
{
	m_Type = type;
	if (pNumber != NULL) {
		m_pszNumber = DupString(pNumber);
	}
	if (pName != NULL) {
		m_pszName = DupString(pName);
	}
	if (pftCallTime != NULL) {
		memcpy(&m_ftCallTime, pftCallTime, sizeof(FILETIME));
	}
	m_dwFlag = dwFlag;
}

CCallLogEntry::~CCallLogEntry()
{
	if (m_pszNumber != NULL) {
		delete [] m_pszNumber;
		m_pszNumber = NULL;
	}
	if (m_pszName != NULL) {
		delete [] m_pszName;
		m_pszName = NULL;
	}
}

CALLLOGENTRY_TYPE
CCallLogEntry::GetType()
{
	return m_Type;
}

LPTSTR
CCallLogEntry::GetNumber()
{
	return m_pszNumber;
}

LPTSTR
CCallLogEntry::GetName()
{
	return m_pszName;
}

FILETIME*
CCallLogEntry::GetTime()
{
	return &m_ftCallTime;
}

DWORD
CCallLogEntry::GetFlag()
{
	return m_dwFlag;
}

BOOL
CCallLogEntry::ConvertToCALLLOGENTRY(
	CALLLOGENTRY* pEntry		// OUT
)
{
	BOOL	bRet = FALSE;

	if (pEntry != NULL) {
		DWORD	dwFlag;

		dwFlag = GetFlag();

		pEntry->cbSize = sizeof(CALLLOGENTRY);

		// ftStartTime
		memcpy(&pEntry->ftStartTime, &m_ftCallTime, sizeof(FILETIME));

		// ftEndTime
		memcpy(&pEntry->ftEndTime, &m_ftCallTime, sizeof(FILETIME));

		// iom(IOM_MISSED,IOM_INCOMING,IOM_OUTGOING)
		if (m_Type == CALLLOGENTRY_TYPE_CALLING) {
			pEntry->iom = IOM_OUTGOING;
		}
		else if (m_Type == CALLLOGENTRY_TYPE_CALLED) {
			if (dwFlag & CALLLOGENTRY_FLAG_MISSED) {
				pEntry->iom = IOM_MISSED;
			}
			else {
				pEntry->iom = IOM_INCOMING;
			}
		}

		// fOutgoing
		if (m_Type == CALLLOGENTRY_TYPE_CALLING) {
			pEntry->fOutgoing = TRUE;
		}
		else if (m_Type == CALLLOGENTRY_TYPE_CALLED) {
			pEntry->fOutgoing = FALSE;
		}

		// fConnected
		if (dwFlag & CALLLOGENTRY_FLAG_MISSED) {
			pEntry->fConnected = FALSE;
		}
		else {
			pEntry->fConnected = TRUE;
		}

		// fEnded
		pEntry->fEnded = FALSE;

		// fRoam
		pEntry->fRoam = FALSE;

		// CALLERIDTYPE cidt
		pEntry->cidt = CALLERIDTYPE_AVAILABLE;

		pEntry->pszNumber = DupStringLocalAlloc(GetNumber());
		pEntry->pszName = DupStringLocalAlloc(GetName());
		pEntry->pszNameType = NULL;
		pEntry->pszNote = NULL;

		bRet = TRUE;
	}

	return bRet;
}
